﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Xml;

using MindFusion.Diagramming.WebForms;
using MindFusion.Diagramming;
using MindFusion.Diagramming.Layout;

using System.Drawing;

namespace OrgBrowser
{
    public partial class Default : System.Web.UI.Page
    {
        RectangleF nodeBounds = new RectangleF(0, 0, 60, 28);

        Color[] colors = new Color[]{Color.FromArgb(184, 156, 156),
                Color.FromArgb(143, 181, 196), Color.FromArgb(152, 184, 134)};
        
      
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Diagram diagram = fc.Diagram;
                diagram.BackBrush = new MindFusion.Drawing.LinearGradientBrush(Color.FromArgb(223, 203, 194),
                    Color.FromArgb(249, 227, 186));
                XmlDocument xmlDoc = new XmlDocument();
                xmlDoc.Load("http://mindfusion.eu/_samples/ASP.NET_OrgChart/employees.xml");
                XmlNode ceo = xmlDoc.SelectSingleNode("Employee");

                ShapeNode root = diagram.Factory.CreateShapeNode(nodeBounds);
                root.Text = "<b>" + ceo["Name"].InnerText + "</b><br> (" + ceo["Title"].InnerText + ")<br>since " +
                    ceo["Date"].InnerText;
                root.Shape = Shape.FromId("RoundRect");
                root.TextPadding = new Thickness(0, 0, 3, 0);
                root.Brush = new MindFusion.Drawing.SolidBrush(Color.FromArgb(121, 109, 173));
                root.TextFormat.Alignment = StringAlignment.Far;
                root.EnableStyledText = true;
                root.ImageUrl = ceo["PhotoUrl"].InnerText;
                root.ImageAlign = MindFusion.Drawing.ImageAlign.MiddleLeft;

                CreateChildren(diagram, root, ceo);

                TreeLayout layout = new TreeLayout();
                layout.Type = TreeLayoutType.Cascading;
                layout.Direction = TreeLayoutDirections.LeftToRight;
                layout.LinkStyle = TreeLayoutLinkType.Cascading2;
                layout.NodeDistance = 3;
                layout.LevelDistance = -8; // let horizontal positions overlap
                layout.Arrange(diagram);
            }
        }

        //cycles through all nodes using recurrence and creates a DiagramNode for all employees
        private void CreateChildren(Diagram diagram, DiagramNode parentDiagNode, XmlNode parentXmlNode)
        {
            foreach (XmlElement element in parentXmlNode.SelectNodes("Employee"))
            {
                ShapeNode node = diagram.Factory.CreateShapeNode(nodeBounds);
                node.Text = "<b>" + element["Name"].InnerText + "</b><br> (" + element["Title"].InnerText + ")<br>since " +
                    element["Date"].InnerText;
                node.TextPadding = new Thickness(0, 0, 3, 0);
                node.TextFormat.Alignment = StringAlignment.Far;
                node.Shape = Shape.FromId("RoundRect");
                node.EnableStyledText = true;
                node.ImageUrl = element["PhotoUrl"].InnerText;
                node.ImageAlign = MindFusion.Drawing.ImageAlign.MiddleLeft;
                node.Brush = new MindFusion.Drawing.SolidBrush(getColor(element));
                diagram.Factory.CreateDiagramLink(parentDiagNode, node);

                CreateChildren(diagram, node, element);
            }
        }

        private Color getColor(XmlNode node)
        {
            string position = node["Level"].InnerText;

            if (position.Equals("Executive"))
                return colors[0];
            else if (position.Equals("Manager"))
                return colors[1];

            return colors[2];
        }

    }
}